#include <stdio.h>
#include "state_funcs.h"

#define ST_WAITJK	0
#define ST_JACKIN	1
#define ST_JACKOUT 2
#define ST_CHERCHEBALLE 3

#define ST_EXIT 99

int state = 0;
int count = 0;
int flag_jack = 0;
              
/**
 * Affiche un message sur le priphrique de sortie
 * remplacer par le code de Gilles, ou quivalent selon le priphrique 
 */
void log(char* msg) {
	printf(msg);
}

/**
 * Dmarrage du robot, premier tat
 */
void initRobot(void) {
	log("Init Robot\n");
   // tests des cartes filles ?
   // premier tat : attente du jack en entre
   state = ST_WAITJK;
   entryWaitjk();
}


/**
 * Analyse le robot, gre les timers, ... (code de Gilles)
 */
void analyseRobot(void) {
	//
   // dclencher le jack de dpart
   flag_jack=1;
}


/************************/
/******** ENTRY *********/
/************************/
void entryWaitjk() {
	//
   log("En attente du jack\n");

}

void entryJackin() {
 	//
   log("Jack entr\n");
}

void entryJackout() {
 	//
   log("Et c'est parti !\n");
   // initialiser le compteur
   //  remplacer par la routine du simulateur (nb de seconde)
	count = 0;
}

void entryChercheballe() {
 	//
   log("Recherche balle\n");
}

/************************/
/********* DO ***********/
/************************/
void doWaitjk() {
	// vrifier une panne ??
	// attendre le jack
   if (flag_jack == 1) {
   	state=ST_JACKIN;
    	exitWaitjk();
      entryJackin();
   }
}

void doJackin() {
 	// attendre la sortie du jack
   if (flag_jack == 0) {
   	state=ST_JACKOUT;
      exitJackin();
      entryJackout();
   }
}

void doJackout() {
 	// analyser le terrain au dmarrage
   // choisir une stratgie

   // dans un premier temps, partir en recherche de balles
	state=ST_CHERCHEBALLE;
   exitJackout();
   entryChercheballe();
   // plus tard, on pourra ajouter des "premiers pas" autoprogramms
}

/************************/
/******** EXIT **********/
/************************/
void exitWaitjk() {
	// nope
}

void exitJackin() {
 	// nope
}

void exitJackout() {
 	// nope
}

/************************/
/******** MAIN **********/
/************************/
int main() {
   initRobot();
   while (state != ST_EXIT) {
      analyseRobot();
		switch (state) {
      	case ST_WAITJK:
         	doWaitjk();
            break;
       	case ST_JACKIN:
         	doJackin();
            break;
       	case ST_JACKOUT:
         	doJackout();
            break;
      }
   }
	return 0;
}